package ast;

import listFW.*;

/**
 * This algorithm returns a String representation of an IList filled with
 * two-element Object pair.
 * Each pair is represented in this format:
 * "<em>[first-element]</em> --> <em>[second-element]</em> "
 * A new-line character is inserted after each pair.
 * An empty list returns an empty String.
 */
public class EnvToStringAlgo implements IListAlgo {
    /**
     * The singleton instance of this class.
     */
    public static EnvToStringAlgo Singleton = new EnvToStringAlgo();

    /**
     * Private constructor used by the Singleton.
     */
    private EnvToStringAlgo() {
    }

    /**
     * Returns an empty String.
     * @param host Not used.
     * @param param Not used.
     * @return "" always.
     */
    public Object emptyCase(IEmptyList host, Object param) {
        return ("");
    }

    /**
     * Returns the String representation of the two-element Object pair assumed
     * to be stored in the host's first.    An new-line and the recursive result
     * from the host's rest is concatenated after the pair's string.
     * @param host The IList that is executing this algorithm.
     * @param param Not used.
     * @return A String representation of the contents of the list.
     */
    public Object nonEmptyCase(INEList host, Object param) {
        Object[] dat = (Object[]) host.getFirst();
        return dat[0]+" --> "+ dat[1] +"\n" + host.getRest().execute(this, param);
    }
}

