
package ast;

/**
 * This interface enforces the constraints of an inductive case situation where
 * the the tree consists of a binary operation with a left-hand side and a
 * right-hand side, both of which are abstract syntax trees.
 */
public interface IBinOp extends IAST {
    /**
     * Accessor method for the left-hand side of the binary operation.
     * @return The left-hand side tree.
     */
    public abstract IAST getLHS();

    /**
     * Accessor method for the right-hand side of the binary operation.
     * @return The right-hand side tree.
     */
    public abstract IAST getRHS();
}

