package ast;

/**
 * This concrete leaf implementation represents an integer.    It's value is
 * thus the value of the integer, as represented by the Java Integer class.
 */
public class IntLeaf implements ILeaf {
    /**
     * The value held is an Integer object.
     */
    private Integer _value;

    /**
     * The constructor for this class.
     * @param val The int value to be held by this leaf.
     * @SBGen Constructor
     */
    public IntLeaf(int val) {
        _value = new Integer(val);
    }

    /**
     * Executes the intLeaf case of  the supplied algorithm with the supplied
     * input parameter.
     * @param algo The algorithm to be executed.
     * @param param The input parameter for the algorithm.
     * @return The return value from executing the intLeaf case of the algorithm.
     */
    public Object execute(IASTAlgo algo, Object param) {
        return algo.intLeafCase(this, param);
    }

    /**
     * Accessor method for the value held by this leaf.
     * @return The Integer object held.
     */
    public Object getValue() {
        return (_value);
    }
}

